// Fill out your copyright notice in the Description page of Project Settings.

#include "MyHelloStoveWidget.h"

#include "Kismet/GameplayStatics.h"
#include "MyStoveSDKObject.h"
#include "Engine.h"

#define OnLog(x, ...)         {\
                                FString log = FString::Printf(TEXT(x), __VA_ARGS__);\
                                OnEventLog(log);\
                              }\
                              UE_LOG(LogTemp, Log, TEXT(x), __VA_ARGS__);\


void UMyHelloStoveWidget::NativeConstruct()
{
	// Call the Blueprint "Event Construct" node
	Super::NativeConstruct();

	// ItemTitle can be nullptr if we haven't created it in the
	// Blueprint subclass



}

bool UMyHelloStoveWidget::Initialize()
{
	bool success = Super::Initialize();
	if (!success)  return false;
	/*remark delete*/
	/*auto stoveSDKObject = Cast<UMyStoveSDKObject>(FindStoveSDKObject());
	stoveSDKObject->_OnDeleLog.BindUObject(this, &UMyHelloStoveWidget::OnEventLog);*/

	if (!ensure(Button_Init != nullptr)) return false;
	Button_Init->OnClicked.AddDynamic(this, &UMyHelloStoveWidget::OnClickInit);

		if (!ensure(Button_UnInit != nullptr)) return false;
	Button_UnInit->OnClicked.AddDynamic(this, &UMyHelloStoveWidget::OnClickUnInit);

	if (!ensure(Button_Token != nullptr)) return false;
	Button_Token->OnClicked.AddDynamic(this, &UMyHelloStoveWidget::OnClickToken);

	if (!ensure(Button_User != nullptr)) return false;
	Button_User->OnClicked.AddDynamic(this, &UMyHelloStoveWidget::OnClickUser);

	if (!ensure(Button_ChangeLevel != nullptr)) return false;
	Button_ChangeLevel->OnClicked.AddDynamic(this, &UMyHelloStoveWidget::OnClickChangeLevel);

	return true;
}

void UMyHelloStoveWidget::OnEventLog(FString log)
{
	FString format = FString::Printf(TEXT("%s\n"), *log);
	_logForm.Append(format);
	if (TextBox_Log)
	{
		TextBox_Log->SetText(FText::FromString(_logForm));
	}
}

void UMyHelloStoveWidget::OnClickInit()
{
	/*remark delete*/
	/*auto stoveSDKObject = Cast<UMyStoveSDKObject>(FindStoveSDKObject());
	stoveSDKObject->StoveSDKInit(FStoveConfig{});*/
}

void UMyHelloStoveWidget::OnClickToken()
{
	/*remark delete*/
	/*auto stoveSDKObject = Cast<UMyStoveSDKObject>(FindStoveSDKObject());
	stoveSDKObject->StoveSDKGetToken();*/
}

void UMyHelloStoveWidget::OnClickUser()
{
	/*remark delete*/
	/*auto stoveSDKObject = Cast<UMyStoveSDKObject>(FindStoveSDKObject());
	stoveSDKObject->StoveSDKGetUser();*/
}

void UMyHelloStoveWidget::OnClickUnInit()
{
	/*remark delete*/
	/*auto stoveSDKObject = Cast<UMyStoveSDKObject>(FindStoveSDKObject());
	stoveSDKObject->StoveSDKUnInit();*/
}

void UMyHelloStoveWidget::OnClickChangeLevel()
{
	UWorld* world = GetWorld();
	FString mapName = world->GetMapName();

	UE_LOG(LogTemp, Log, TEXT("%s"), *mapName);
	if (mapName.Contains(FString("HelloStoveMap_2")))
	{
		UGameplayStatics::OpenLevel(GetWorld(), "HelloStoveMap");
		GEngine->AddOnScreenDebugMessage(-1, 15.0f, FColor::Yellow, TEXT("Change game level - HelloStoveMap"));
	}
	else
	{
		UGameplayStatics::OpenLevel(GetWorld(), "HelloStoveMap_2");
		GEngine->AddOnScreenDebugMessage(-1, 15.0f, FColor::Yellow, TEXT("Change game level - HelloStoveMap_2"));
	}
}

