// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Blueprint/UserWidget.h"
#include "Components/MultiLineEditableTextBox.h"
#include "Components/EditableTextBox.h"
#include "Components/Button.h"
#include "MyHelloStoveWidget.generated.h"

/**
 *
 */
UCLASS()
class HELLOSTOVE_API UMyHelloStoveWidget : public UUserWidget
{
	GENERATED_BODY()
public:
	virtual void NativeConstruct() override;

	UPROPERTY(BlueprintReadOnly, meta = (BindWidget))
		class UMultiLineEditableTextBox* TextBox_Log;

	UPROPERTY(BlueprintReadOnly, meta = (BindWidget))
		class UButton* Button_Init;

	UPROPERTY(BlueprintReadOnly, meta = (BindWidget))
		class UButton* Button_UnInit;

	UPROPERTY(BlueprintReadOnly, meta = (BindWidget))
		class UButton* Button_Token;

	UPROPERTY(BlueprintReadOnly, meta = (BindWidget))
		class UButton* Button_User;

	UPROPERTY(BlueprintReadOnly, meta = (BindWidget))
		class UButton* Button_ChangeLevel;

	void OnEventLog(FString log);


	UFUNCTION(BlueprintCallable, Category = "Widget")
		void OnClickInit();

	UFUNCTION(BlueprintCallable, Category = "Widget")
		void OnClickToken();

	UFUNCTION(BlueprintCallable, Category = "Widget")
		void OnClickUser();

	UFUNCTION(BlueprintCallable, Category = "Widget")
		void OnClickUnInit();

	UFUNCTION(BlueprintCallable, Category = "Widget")
		void OnClickChangeLevel();

protected:
	virtual bool Initialize() override;


private:
	FString _logForm;
};
