// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "StoveSDKEmptyObject.h"
#include "MyStoveSDKObject.generated.h"

DECLARE_DELEGATE_OneParam(FDele_Delegate_Log, FString);


/**
 * 
 */
UCLASS()
class HELLOSTOVE_API UMyStoveSDKObject : public UStoveSDKEmptyObject
{
	GENERATED_BODY()
public:
	UMyStoveSDKObject() {};

	//StoveAPI
public:

    // Versions or higher v2.4.1
    FStoveResult StoveSDKInit(const FStoveConfig& Config) override;
    /* Versions less then v2.4.1
	FStoveResult StoveSDKInit(FStoveConfig fConfig) override;
    */
	FStoveResult StoveSDKGetToken() override;
	FStoveResult StoveSDKGetUser() override;
	FStoveResult StoveSDKUnInit() override;


	//StoveCallback
public:

	virtual void OnInitComplete() override;
	virtual void OnError(FStoveError Error) override;
	virtual void OnToken(FStoveToken Token) override;
	virtual void OnUser(FStoveUser User) override;


public:
	FDele_Delegate_Log _OnDeleLog;
};
