// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "StoveSDKEmptyObject.generated.h"

typedef int FStoveResult;
typedef int FStoveConfig;
typedef int FStoveError;
typedef int FStoveToken;
typedef int FStoveUser;
typedef int FStoveOwnership;

/**
 * 
 */
UCLASS()
class HELLOSTOVE_API UStoveSDKEmptyObject : public UObject
{
	GENERATED_BODY()
public:
	UStoveSDKEmptyObject() {};

	//StoveAPI
public:
    // v2.4.1 or higher version
    virtual FStoveResult StoveSDKInit(const FStoveConfig& Config) { return FStoveResult{ 0 }; };

    /* Versions less then v2.4.1
	//virtual FStoveResult StoveSDKInit(FStoveConfig config) { return FStoveResult{ 0 }; };
    */

	virtual FStoveResult StoveSDKGetToken() { return FStoveResult{ 0 }; };
	virtual FStoveResult StoveSDKGetUser() { return FStoveResult{ 0 }; };
	virtual FStoveResult StoveSDKUnInit() { return FStoveResult{ 0 }; };

public:
	//StovePCSDK Event
	virtual void OnError(FStoveError Error) {};
	virtual void OnInitComplete() {};
	virtual void OnToken(FStoveToken Token) {};
	virtual void OnUser(FStoveUser User) {};
	
};
